/* Audio Library for Teensy 3.X
 * Copyright (c) 2014, Alessandro Fasan
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include "effect_karaoke.h"

/******************************************************************/

//                A u d i o E f f e c t K a r a o k e
// Written by Alessandro Fasan Jan 2014

boolean AudioEffectKaraoke::begin()
{
Serial.println("AudioEffectKaraoke... Begin ");
  return(true);
}


void AudioEffectKaraoke::update(void)
{
  audio_block_t *block_l, *block_r;
  short *bp_l, *bp_r;
  int diff;
  
 	
	block_l = receiveWritable(0);
	block_r = receiveWritable(1);
	if((block_r) && (block_l)) {
		bp_l = block_l-> data;
		bp_r = block_r-> data;
		for(int i = 0;i < AUDIO_BLOCK_SAMPLES;i++) {
			diff = *bp_r - *bp_l;
			if(!done) {
				Serial.print("bp_r = ");
				Serial.print(*bp_r);
				Serial.print(" bp_l = ");
				Serial.print(*bp_l);
				Serial.print(" Diff = " );
				Serial.println(diff);
				}
			*bp_l++ = diff;
			*bp_r++ = diff;
			}
		if(!done) done = true; // do this only for the first block
		transmit(block_l,0);
		release(block_l);
		transmit(block_r,1);
		release(block_r);
	
	}
	
	
}



