/* Audio Library for Teensy 3.X
 * Copyright (c) 2014, Alessandro Fasan
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#ifndef effect_karaoke_h_
#define effect_karaoke_h_

#include "AudioStream.h"

/******************************************************************/

//                A u d i o E f f e c t K a r a o k e
// Written by Alessandro Fasan Jan 2014

#define KARAOKE_DELAY_PASSTHRU -1

class AudioEffectKaraoke : 
public AudioStream
{
public:
  AudioEffectKaraoke(void):
  AudioStream(2,inputQueueArray) 
  { }

  boolean begin();
  virtual void update(void);
  //void stop(void);
  //void modify(int n_chorus);
  
private:
  audio_block_t *inputQueueArray[2];
  bool done = false;

};

#endif
