
#include <Audio.h>
#include <Wire.h>
#include <SD.h>


const int myInput = AUDIO_INPUT_LINEIN;

AudioInputI2S       audioInput;         // audio shield: mic or line-in
AudioEffectKaraoke   myEffect;
AudioOutputI2S      audioOutput;        // audio shield: headphones & line-out

// Create Audio connections between the components
// Both channels of the audio input go to the karaoke effect
AudioConnection c1(audioInput, 0, myEffect, 0);
AudioConnection c2(audioInput, 1, myEffect, 1);
// the karaoke effect is now mono, goes to both audio output channels
AudioConnection c3(myEffect, 0, audioOutput, 0);
AudioConnection c4(myEffect, 1, audioOutput, 1);

AudioControlSGTL5000 audioShield;

// <<<<<<<<<<<<<<>>>>>>>>>>>>>>>>
void setup() {
  
  Serial.begin(9600);
  while (!Serial) ;
  delay(1000);


  // Maximum memory usage was reported as 4
  // Proc = 1 (1),  Mem = 4 (4)
  AudioMemory(8);

  audioShield.enable();
  audioShield.inputSelect(myInput);
  audioShield.volume(0.6);
 
  // Initialize the effect
  if(!myEffect.begin()) {
    Serial.println("AudioEffectChorus - begin failed");
    while(1);
  }
  
  audioShield.unmuteLineout();
  Serial.println("Setup Karaoke done");

}


// audio volume

void loop()
{
  // Volume control
  int n = analogRead(15);
  audioShield.volume( n / 1023.);
  delay(1000);
}

